#!/bin/sh
rm -f *err *lst *.p
asl mdos1.a80 -L -E mdos1.err
p2bin mdos1.p -r 0-16383
asl mdos2.a80 -L -E mdos2.err
p2bin mdos2.p -r 0-16383
asl nmi.a80 -L -E nmi.err
p2bin nmi.p -r 8192-16383
rm -f *.p
cat nmi.err mdos1.err mdos2.err > mdos3.err
rm -f nmi.err mdos1.err mdos2.err
if [ -s mdos3.err ] 
then
 echo "Chybna kompilace"
 cat mdos3.err
else
 rm -f mdos3.err
 split mdos1.bin mdos1_ -b 8k
 #vystup mdos1_aa a mdos1_ab soubory a budou vzdy 2
 mv mdos1_aa mdos1_3.bin
 mv mdos1_ab mdos1_0.bin
 cp nmi.bin mdos1_1.bin
 bin2tap mdos1_3.bin -a 0
 bin2tap mdos1_0.bin -a 8192
 bin2tap mdos1_1.bin -a 8192
 
 split mdos2.bin mdos2_ -b 8k
 #vystup mdos2_aa a mdos2_ab soubory a budou vzdy 2
 mv mdos2_aa mdos2_3.bin
 mv mdos2_ab mdos2_0.bin
 cp nmi.bin mdos2_1.bin
 bin2tap mdos2_3.bin -a 0
 bin2tap mdos2_0.bin -a 8192
 bin2tap mdos2_1.bin -a 8192
 cat mdos1_3.tap mdos1_0.tap mdos1_1.tap mdos2_3.tap mdos2_0.tap mdos2_1.tap > mdos3.tap
 rm -f mdos1_?.tap mdos2_?.tap
 tap2d80 mdos3.tap mdos3.d80
fi
